/**************************************************************************
**
**      FILE        :  tri.dsc
**
**      VERSION     :  @(#)tri.dsc	1.38 03/05/09
**
**      DESCRIPTION :  Locator software description
**
**      Copyright 1996-2003 Altium BV
**
**************************************************************************/

software
{
	load_mod start = _START;
	layout
	{
		space	mem_space
		{
		block	mem_block
		{
		cluster	mem_cluster
		{
			// ----------------------------------------
			// reserved areas
			// ----------------------------------------
#define RESERVED(B,E)	amode	linear\
			{\
				reserved addr=(B) length=(E)-(B)+1;\
			}
#include <tri.def>

#if ! TMON
// when using the ROM monitor this reset vector must avoid the monitor's
			// ----------------------------------------
			// fixed section address and/or section order
			// ----------------------------------------
			amode	linear
			{
				section reset addr = (RESET);
			}
#endif /* TMON */
			amode	linear
			{
#define ROM_LINEAR(SECTION)	section SECTION attr = 1r;
#include <tri.def>
			}
			amode	abs24
			{
#define ROM_ABS24(SECTION)	section SECTION attr = 1r;
#include <tri.def>
			}
			amode	abs18
			{
#define ROM_ABS18(SECTION)	section SECTION attr = 1r;
#include <tri.def>
			}
			amode	linear
			{
#define RAM_LINEAR(SECTION)	section SECTION attr = 2w;
#include <tri.def>
			}
			amode	abs18
			{
#define RAM_ABS18(SECTION)	section SECTION attr = 2w;
#include <tri.def>
			}

			// ----------------------------------------
			// DATA section allocation
			// ----------------------------------------
			amode	abs18
			{	// DATA,ABS18,ROMDATA
				section selection = r attr = 2;
			}
			amode	abs18
			{	// DATA,ABS18
				section selection = w attr = 2;
			}
			amode	abs18
			{	// DATA,ABS18,INIT
				section selection = wi attr = 2;
			}
			amode	abs18
			{	// DATA,ABS18,CLEAR
				section selection = wb attr = 2;
			}
			amode	linear
			{	// DATA,ROMDATA
				section selection = r attr = 2;
			}
			amode	linear
			{	// DATA
				section selection = w attr = 2;
			}
			amode	linear
			{	// DATA,INIT
				section selection = wi attr = 2;
			}
			amode	linear
			{	// DATA,CLEAR
				section selection = wb attr = 2;
			}
			amode	linear
			{ 	// copy table, init data
				table;
				copy;
			}
			amode	pcpdata
			{
				section selection = wi attr = 2;
				section selection = wb attr = 2;
				section selection = w  attr = 2;
			}

			// ----------------------------------------
			// CODE section allocation
			// ----------------------------------------
			amode	linear
			{
				section selection = x attr = 1;
			}
			amode	abs24
			{
				section selection = x attr = 1;
			}
			amode	pcpcode
			{
				section selection = x attr = 1;
			}

			// ----------------------------------------
			// special sections
			// ----------------------------------------
			amode	linear
			{
				reserved label = xvwbuffer length = XVWBUF attr = 2w;
			}
			amode	abscsa
			{
#ifdef _CPU_TC051
	//
	//	CPU_TC051 workaround:
	//		The Context Save Area address range is restricted 
	//		to just 3 areas of 4k in the 24Kb scratch pad ram
	//		(DMU) of the tc1910/tc1912 and tc1920. These areas
	//		start at an 8k boundary.
#if (CSA <= 64)
				reserved label = csa.01 length = 64 * CSA	attr = 13w;
				reserved label = csa.02 length = 0		attr = 13w;
				reserved label = csa.03 length = 0		attr = 13w;
#elif (CSA > 64 && CSA <= 128)
				reserved label = csa.01 length = 4k		attr = 13w;
				reserved label = csa.02 length = 64 * CSA - 4k  attr = 13w;
				reserved label = csa.03 length = 0		attr = 13w;
#elif (CSA > 128)
				reserved label = csa.01 length = 4k		attr = 13w;
				reserved label = csa.02 length = 4k		attr = 13w;
				reserved label = csa.03 length = 64 * CSA - 8k	attr = 13w;
#endif
#else
				reserved label = csa length = 64 * CSA attr = 6w;
#endif
			}
			amode	linear
			{
#ifdef _TC112_COR16
	//
	//	TC112_COR16 workaround:
	//		The stack pointers are aligned to quad-word boundary
	//		to workaround the TC112_COR16 functional problem.
	//		Also C compiler workaround for this CPU function problem
	//		need to be enabled with -zTC112_COR16, to align circular
	//		buffers on a quad-word boundary and to size all stack 
	//		frames to an integral number of quad-words.
				reserved label = ustack length = USTACK attr = 4w;
#else
				reserved label = ustack length = USTACK attr = 3w;
#endif
			}
			amode	linear
			{
#ifdef _TC112_COR16
	//
	//	TC112_COR16 workaround:
	//		The stack pointers are aligned to quad-word boundary
	//		to workaround the TC112_COR16 functional problem.
	//		Also C compiler workaround for this CPU function problem
	//		need to be enabled with -zTC112_COR16, to align circular
	//		buffers on a quad-word boundary and to size all stack 
	//		frames to an integral number of quad-words.
				reserved label = istack length = ISTACK attr = 4w;
#else
				reserved label = istack length = ISTACK attr = 3w;
#endif
			}
			amode	linear
			{
				label a0;
				section a0data attr = 2;
				section a0bss  attr = 2;
				section a0rom  attr = 2;
			}
			amode	linear
			{
				label a1;
				section a1data attr = 2;
				section a1bss  attr = 2;
				section a1rom  attr = 2;
			}
			amode	linear
			{
				label a8;
				section a8data attr = 2;
				section a8bss  attr = 2;
				section a8rom  attr = 2;
			}
			amode	linear
			{
				label a9;
				section a9data attr = 2;
				section a9bss  attr = 2;
				section a9rom  attr = 2;
			}
			amode	linear
			{
				label int_tab addr = (INTTAB);
//usr/bin/perl -e 'for($i=0;$i<256;$i++){printf"\t\t\t\tsection intvec.%02x addr = (INTTAB)+0x%04x;\n",$i,32*$i;}'
				section intvec.00 addr = (INTTAB)+0x0000;
				section intvec.01 addr = (INTTAB)+0x0020;
				section intvec.02 addr = (INTTAB)+0x0040;
				section intvec.03 addr = (INTTAB)+0x0060;
				section intvec.04 addr = (INTTAB)+0x0080;
				section intvec.05 addr = (INTTAB)+0x00a0;
				section intvec.06 addr = (INTTAB)+0x00c0;
				section intvec.07 addr = (INTTAB)+0x00e0;
				section intvec.08 addr = (INTTAB)+0x0100;
				section intvec.09 addr = (INTTAB)+0x0120;
				section intvec.0a addr = (INTTAB)+0x0140;
				section intvec.0b addr = (INTTAB)+0x0160;
				section intvec.0c addr = (INTTAB)+0x0180;
				section intvec.0d addr = (INTTAB)+0x01a0;
				section intvec.0e addr = (INTTAB)+0x01c0;
				section intvec.0f addr = (INTTAB)+0x01e0;
				section intvec.10 addr = (INTTAB)+0x0200;
				section intvec.11 addr = (INTTAB)+0x0220;
				section intvec.12 addr = (INTTAB)+0x0240;
				section intvec.13 addr = (INTTAB)+0x0260;
				section intvec.14 addr = (INTTAB)+0x0280;
				section intvec.15 addr = (INTTAB)+0x02a0;
				section intvec.16 addr = (INTTAB)+0x02c0;
				section intvec.17 addr = (INTTAB)+0x02e0;
				section intvec.18 addr = (INTTAB)+0x0300;
				section intvec.19 addr = (INTTAB)+0x0320;
				section intvec.1a addr = (INTTAB)+0x0340;
				section intvec.1b addr = (INTTAB)+0x0360;
				section intvec.1c addr = (INTTAB)+0x0380;
				section intvec.1d addr = (INTTAB)+0x03a0;
				section intvec.1e addr = (INTTAB)+0x03c0;
				section intvec.1f addr = (INTTAB)+0x03e0;
				section intvec.20 addr = (INTTAB)+0x0400;
				section intvec.21 addr = (INTTAB)+0x0420;
				section intvec.22 addr = (INTTAB)+0x0440;
				section intvec.23 addr = (INTTAB)+0x0460;
				section intvec.24 addr = (INTTAB)+0x0480;
				section intvec.25 addr = (INTTAB)+0x04a0;
				section intvec.26 addr = (INTTAB)+0x04c0;
				section intvec.27 addr = (INTTAB)+0x04e0;
				section intvec.28 addr = (INTTAB)+0x0500;
				section intvec.29 addr = (INTTAB)+0x0520;
				section intvec.2a addr = (INTTAB)+0x0540;
				section intvec.2b addr = (INTTAB)+0x0560;
				section intvec.2c addr = (INTTAB)+0x0580;
				section intvec.2d addr = (INTTAB)+0x05a0;
				section intvec.2e addr = (INTTAB)+0x05c0;
				section intvec.2f addr = (INTTAB)+0x05e0;
				section intvec.30 addr = (INTTAB)+0x0600;
				section intvec.31 addr = (INTTAB)+0x0620;
				section intvec.32 addr = (INTTAB)+0x0640;
				section intvec.33 addr = (INTTAB)+0x0660;
				section intvec.34 addr = (INTTAB)+0x0680;
				section intvec.35 addr = (INTTAB)+0x06a0;
				section intvec.36 addr = (INTTAB)+0x06c0;
				section intvec.37 addr = (INTTAB)+0x06e0;
				section intvec.38 addr = (INTTAB)+0x0700;
				section intvec.39 addr = (INTTAB)+0x0720;
				section intvec.3a addr = (INTTAB)+0x0740;
				section intvec.3b addr = (INTTAB)+0x0760;
				section intvec.3c addr = (INTTAB)+0x0780;
				section intvec.3d addr = (INTTAB)+0x07a0;
				section intvec.3e addr = (INTTAB)+0x07c0;
				section intvec.3f addr = (INTTAB)+0x07e0;
				section intvec.40 addr = (INTTAB)+0x0800;
				section intvec.41 addr = (INTTAB)+0x0820;
				section intvec.42 addr = (INTTAB)+0x0840;
				section intvec.43 addr = (INTTAB)+0x0860;
				section intvec.44 addr = (INTTAB)+0x0880;
				section intvec.45 addr = (INTTAB)+0x08a0;
				section intvec.46 addr = (INTTAB)+0x08c0;
				section intvec.47 addr = (INTTAB)+0x08e0;
				section intvec.48 addr = (INTTAB)+0x0900;
				section intvec.49 addr = (INTTAB)+0x0920;
				section intvec.4a addr = (INTTAB)+0x0940;
				section intvec.4b addr = (INTTAB)+0x0960;
				section intvec.4c addr = (INTTAB)+0x0980;
				section intvec.4d addr = (INTTAB)+0x09a0;
				section intvec.4e addr = (INTTAB)+0x09c0;
				section intvec.4f addr = (INTTAB)+0x09e0;
				section intvec.50 addr = (INTTAB)+0x0a00;
				section intvec.51 addr = (INTTAB)+0x0a20;
				section intvec.52 addr = (INTTAB)+0x0a40;
				section intvec.53 addr = (INTTAB)+0x0a60;
				section intvec.54 addr = (INTTAB)+0x0a80;
				section intvec.55 addr = (INTTAB)+0x0aa0;
				section intvec.56 addr = (INTTAB)+0x0ac0;
				section intvec.57 addr = (INTTAB)+0x0ae0;
				section intvec.58 addr = (INTTAB)+0x0b00;
				section intvec.59 addr = (INTTAB)+0x0b20;
				section intvec.5a addr = (INTTAB)+0x0b40;
				section intvec.5b addr = (INTTAB)+0x0b60;
				section intvec.5c addr = (INTTAB)+0x0b80;
				section intvec.5d addr = (INTTAB)+0x0ba0;
				section intvec.5e addr = (INTTAB)+0x0bc0;
				section intvec.5f addr = (INTTAB)+0x0be0;
				section intvec.60 addr = (INTTAB)+0x0c00;
				section intvec.61 addr = (INTTAB)+0x0c20;
				section intvec.62 addr = (INTTAB)+0x0c40;
				section intvec.63 addr = (INTTAB)+0x0c60;
				section intvec.64 addr = (INTTAB)+0x0c80;
				section intvec.65 addr = (INTTAB)+0x0ca0;
				section intvec.66 addr = (INTTAB)+0x0cc0;
				section intvec.67 addr = (INTTAB)+0x0ce0;
				section intvec.68 addr = (INTTAB)+0x0d00;
				section intvec.69 addr = (INTTAB)+0x0d20;
				section intvec.6a addr = (INTTAB)+0x0d40;
				section intvec.6b addr = (INTTAB)+0x0d60;
				section intvec.6c addr = (INTTAB)+0x0d80;
				section intvec.6d addr = (INTTAB)+0x0da0;
				section intvec.6e addr = (INTTAB)+0x0dc0;
				section intvec.6f addr = (INTTAB)+0x0de0;
				section intvec.70 addr = (INTTAB)+0x0e00;
				section intvec.71 addr = (INTTAB)+0x0e20;
				section intvec.72 addr = (INTTAB)+0x0e40;
				section intvec.73 addr = (INTTAB)+0x0e60;
				section intvec.74 addr = (INTTAB)+0x0e80;
				section intvec.75 addr = (INTTAB)+0x0ea0;
				section intvec.76 addr = (INTTAB)+0x0ec0;
				section intvec.77 addr = (INTTAB)+0x0ee0;
				section intvec.78 addr = (INTTAB)+0x0f00;
				section intvec.79 addr = (INTTAB)+0x0f20;
				section intvec.7a addr = (INTTAB)+0x0f40;
				section intvec.7b addr = (INTTAB)+0x0f60;
				section intvec.7c addr = (INTTAB)+0x0f80;
				section intvec.7d addr = (INTTAB)+0x0fa0;
				section intvec.7e addr = (INTTAB)+0x0fc0;
				section intvec.7f addr = (INTTAB)+0x0fe0;
				section intvec.80 addr = (INTTAB)+0x1000;
				section intvec.81 addr = (INTTAB)+0x1020;
				section intvec.82 addr = (INTTAB)+0x1040;
				section intvec.83 addr = (INTTAB)+0x1060;
				section intvec.84 addr = (INTTAB)+0x1080;
				section intvec.85 addr = (INTTAB)+0x10a0;
				section intvec.86 addr = (INTTAB)+0x10c0;
				section intvec.87 addr = (INTTAB)+0x10e0;
				section intvec.88 addr = (INTTAB)+0x1100;
				section intvec.89 addr = (INTTAB)+0x1120;
				section intvec.8a addr = (INTTAB)+0x1140;
				section intvec.8b addr = (INTTAB)+0x1160;
				section intvec.8c addr = (INTTAB)+0x1180;
				section intvec.8d addr = (INTTAB)+0x11a0;
				section intvec.8e addr = (INTTAB)+0x11c0;
				section intvec.8f addr = (INTTAB)+0x11e0;
				section intvec.90 addr = (INTTAB)+0x1200;
				section intvec.91 addr = (INTTAB)+0x1220;
				section intvec.92 addr = (INTTAB)+0x1240;
				section intvec.93 addr = (INTTAB)+0x1260;
				section intvec.94 addr = (INTTAB)+0x1280;
				section intvec.95 addr = (INTTAB)+0x12a0;
				section intvec.96 addr = (INTTAB)+0x12c0;
				section intvec.97 addr = (INTTAB)+0x12e0;
				section intvec.98 addr = (INTTAB)+0x1300;
				section intvec.99 addr = (INTTAB)+0x1320;
				section intvec.9a addr = (INTTAB)+0x1340;
				section intvec.9b addr = (INTTAB)+0x1360;
				section intvec.9c addr = (INTTAB)+0x1380;
				section intvec.9d addr = (INTTAB)+0x13a0;
				section intvec.9e addr = (INTTAB)+0x13c0;
				section intvec.9f addr = (INTTAB)+0x13e0;
				section intvec.a0 addr = (INTTAB)+0x1400;
				section intvec.a1 addr = (INTTAB)+0x1420;
				section intvec.a2 addr = (INTTAB)+0x1440;
				section intvec.a3 addr = (INTTAB)+0x1460;
				section intvec.a4 addr = (INTTAB)+0x1480;
				section intvec.a5 addr = (INTTAB)+0x14a0;
				section intvec.a6 addr = (INTTAB)+0x14c0;
				section intvec.a7 addr = (INTTAB)+0x14e0;
				section intvec.a8 addr = (INTTAB)+0x1500;
				section intvec.a9 addr = (INTTAB)+0x1520;
				section intvec.aa addr = (INTTAB)+0x1540;
				section intvec.ab addr = (INTTAB)+0x1560;
				section intvec.ac addr = (INTTAB)+0x1580;
				section intvec.ad addr = (INTTAB)+0x15a0;
				section intvec.ae addr = (INTTAB)+0x15c0;
				section intvec.af addr = (INTTAB)+0x15e0;
				section intvec.b0 addr = (INTTAB)+0x1600;
				section intvec.b1 addr = (INTTAB)+0x1620;
				section intvec.b2 addr = (INTTAB)+0x1640;
				section intvec.b3 addr = (INTTAB)+0x1660;
				section intvec.b4 addr = (INTTAB)+0x1680;
				section intvec.b5 addr = (INTTAB)+0x16a0;
				section intvec.b6 addr = (INTTAB)+0x16c0;
				section intvec.b7 addr = (INTTAB)+0x16e0;
				section intvec.b8 addr = (INTTAB)+0x1700;
				section intvec.b9 addr = (INTTAB)+0x1720;
				section intvec.ba addr = (INTTAB)+0x1740;
				section intvec.bb addr = (INTTAB)+0x1760;
				section intvec.bc addr = (INTTAB)+0x1780;
				section intvec.bd addr = (INTTAB)+0x17a0;
				section intvec.be addr = (INTTAB)+0x17c0;
				section intvec.bf addr = (INTTAB)+0x17e0;
				section intvec.c0 addr = (INTTAB)+0x1800;
				section intvec.c1 addr = (INTTAB)+0x1820;
				section intvec.c2 addr = (INTTAB)+0x1840;
				section intvec.c3 addr = (INTTAB)+0x1860;
				section intvec.c4 addr = (INTTAB)+0x1880;
				section intvec.c5 addr = (INTTAB)+0x18a0;
				section intvec.c6 addr = (INTTAB)+0x18c0;
				section intvec.c7 addr = (INTTAB)+0x18e0;
				section intvec.c8 addr = (INTTAB)+0x1900;
				section intvec.c9 addr = (INTTAB)+0x1920;
				section intvec.ca addr = (INTTAB)+0x1940;
				section intvec.cb addr = (INTTAB)+0x1960;
				section intvec.cc addr = (INTTAB)+0x1980;
				section intvec.cd addr = (INTTAB)+0x19a0;
				section intvec.ce addr = (INTTAB)+0x19c0;
				section intvec.cf addr = (INTTAB)+0x19e0;
				section intvec.d0 addr = (INTTAB)+0x1a00;
				section intvec.d1 addr = (INTTAB)+0x1a20;
				section intvec.d2 addr = (INTTAB)+0x1a40;
				section intvec.d3 addr = (INTTAB)+0x1a60;
				section intvec.d4 addr = (INTTAB)+0x1a80;
				section intvec.d5 addr = (INTTAB)+0x1aa0;
				section intvec.d6 addr = (INTTAB)+0x1ac0;
				section intvec.d7 addr = (INTTAB)+0x1ae0;
				section intvec.d8 addr = (INTTAB)+0x1b00;
				section intvec.d9 addr = (INTTAB)+0x1b20;
				section intvec.da addr = (INTTAB)+0x1b40;
				section intvec.db addr = (INTTAB)+0x1b60;
				section intvec.dc addr = (INTTAB)+0x1b80;
				section intvec.dd addr = (INTTAB)+0x1ba0;
				section intvec.de addr = (INTTAB)+0x1bc0;
				section intvec.df addr = (INTTAB)+0x1be0;
				section intvec.e0 addr = (INTTAB)+0x1c00;
				section intvec.e1 addr = (INTTAB)+0x1c20;
				section intvec.e2 addr = (INTTAB)+0x1c40;
				section intvec.e3 addr = (INTTAB)+0x1c60;
				section intvec.e4 addr = (INTTAB)+0x1c80;
				section intvec.e5 addr = (INTTAB)+0x1ca0;
				section intvec.e6 addr = (INTTAB)+0x1cc0;
				section intvec.e7 addr = (INTTAB)+0x1ce0;
				section intvec.e8 addr = (INTTAB)+0x1d00;
				section intvec.e9 addr = (INTTAB)+0x1d20;
				section intvec.ea addr = (INTTAB)+0x1d40;
				section intvec.eb addr = (INTTAB)+0x1d60;
				section intvec.ec addr = (INTTAB)+0x1d80;
				section intvec.ed addr = (INTTAB)+0x1da0;
				section intvec.ee addr = (INTTAB)+0x1dc0;
				section intvec.ef addr = (INTTAB)+0x1de0;
				section intvec.f0 addr = (INTTAB)+0x1e00;
				section intvec.f1 addr = (INTTAB)+0x1e20;
				section intvec.f2 addr = (INTTAB)+0x1e40;
				section intvec.f3 addr = (INTTAB)+0x1e60;
				section intvec.f4 addr = (INTTAB)+0x1e80;
				section intvec.f5 addr = (INTTAB)+0x1ea0;
				section intvec.f6 addr = (INTTAB)+0x1ec0;
				section intvec.f7 addr = (INTTAB)+0x1ee0;
				section intvec.f8 addr = (INTTAB)+0x1f00;
				section intvec.f9 addr = (INTTAB)+0x1f20;
				section intvec.fa addr = (INTTAB)+0x1f40;
				section intvec.fb addr = (INTTAB)+0x1f60;
				section intvec.fc addr = (INTTAB)+0x1f80;
				section intvec.fd addr = (INTTAB)+0x1fa0;
				section intvec.fe addr = (INTTAB)+0x1fc0;
				section intvec.ff addr = (INTTAB)+0x1fe0;
			}
			amode	linear
			{
				label trap_tab addr = (TRAPTAB);
//usr/bin/perl -e 'for($i=0;$i<8;$i++){printf"\t\t\t\tsection trapvec.%02x addr = (TRAPTAB)+0x%04x;\n",$i,32*$i;}'
				section trapvec.00 addr = (TRAPTAB)+0x0000;
                                section trapvec.01 addr = (TRAPTAB)+0x0020;
                                section trapvec.02 addr = (TRAPTAB)+0x0040;
                                section trapvec.03 addr = (TRAPTAB)+0x0060;
                                section trapvec.04 addr = (TRAPTAB)+0x0080;
                                section trapvec.05 addr = (TRAPTAB)+0x00a0;
                                section trapvec.06 addr = (TRAPTAB)+0x00c0;
                                section trapvec.07 addr = (TRAPTAB)+0x00e0;  
			}
			amode	linear
			{
				heap length = HEAP attr = 3w;
			}
		}
		}
		}
	}
}

#include <tri.cpu>
