/**************************************************************************
**                                                                        *
**  FILE        :  longjmp.c                                              *
**                                                                        *
**  DESCRIPTION :  Source file for longjmp function                       *
**                 The longjmp function restores the environment saved by *
**                 the most recent invocation of the program, with the    *
**                 corresponding jmp_buf argument. The longjmp function   *
**                 cause setjmp to return "val". The                      *
**                 longjmp function cannot cause setjmp to return the     *
**                 value 0. If "val" is 0, then setjmp returns 1.         *
**                                                                        *
**  Copyright 1996-2002 Altium BV                                         *
**                                                                        *
**************************************************************************/

#include        <setjmp.h>

void    longjmp ( jmp_buf env, int val )
{
        env;                    /* prevent warning */
        val;                    /* prevent warning */
#pragma asm

; macro for loading 32bit constants into address regisers
CONST.A .MACRO  ax,v
        movh.a  ax,#@his(v)     ; high part with correction for signed addition
        lea     ax,[ax]@los(v)
        .ENDM
;
;       TC112_COR4 workaround:
;       
.if @DEF('_TC112_COR4')
        nop
.endif  
        ld.w    d5,[a4]4        ; get saved PCXI
loop:
        mfcr    d2,#PCXI        ; get current PCXI value
        jne     d2,d5,continue
        max.u   d2,d4,#1        ; retval = (val ? val : 1);
        ld.a    a2,[a4]         ; get saved return address
;
;       TC113_CPU11, TC113_CPU16 and CPU_TC048  workaround:
;
.if @DEF('_TC113_CPU11') || @DEF('_TC113_CPU16') || @DEF('_CPU_TC048') 
        nop
.endif
        ji      a2              ; return from setjmp() call
continue:
        jnz.t   d2:22,upper     ; upper context block
lower:
        mov16.aa a15,a4         ; save 'env'
        mov16   d15,d4          ; save 'val'
        rslcx                   ; remove lower context block
        mov16   d4,d15          ; restore 'val'
        mov16.aa a4,a15         ; restore 'env'
        j16     longjmp         ; continue with next context block
upper:
        CONST.A a11,loop        ; load fake return address
                                ; pop one context block and jump back to loop
#pragma endasm
}
