/**************************************************************************
**                                                                        *
**  FILE        :  setjmp.c                                               *
**                                                                        *
**  DESCRIPTION :  Source file for setjmp function                        *
**                 The setjmp function saves its calling environment in   *
**                 its jmp_buf for later use by the longjmp function.     *
**                 If the return is from a direct invocation, the setjmp  *
**                 function returns zero. If the return is from a call to *
**                 the longjmp, the setjmp function returns a nonzero     *
**                 value.                                                 *
**                                                                        *
**  Copyright 1996-2002 Altium BV                                         *
**                                                                        *
**************************************************************************/

#include        <setjmp.h>

int     setjmp ( jmp_buf env )
{
#pragma asm

; macro for loading 32bit constants into address regisers
CONST.A .MACRO  ax,v
        movh.a  ax,#@his(v)     ; high part with correction for signed addition
        lea     ax,[ax]@los(v)
        .ENDM
;
;       TC112_COR4 workaround:
;       
.if @DEF('_TC112_COR4')
        nop
.endif
        st.a    [a4],a11        ; save return address
        CONST.A a11,next        ; load fake return address
        ret                     ; pop one context block
next:
        mfcr    d2,#PCXI        ; get PCXI value of caller
        st.w    [a4]4,d2        ; save PCXI
        ld.a    a2,[a4]         ; retrieve return address
        mov     d2,#0           ; return 0
;
;       TC113_CPU11, TC113_CPU16 and CPU_TC048  workaround:
;
.if @DEF('_TC113_CPU11') || @DEF('_TC113_CPU16') || @DEF('_CPU_TC048') 
        nop
.endif
        ji      a2              ; jump back to caller

#pragma endasm
        env;                    /* prevent warning */
        return 0;               /* prevent warning */
}
